<?php
/** 
 *	iCagenda - iC calendar
 *----------------------------------------------------------------------------
 * @package     com_icagenda
 * @copyright	Copyright (C) 2012 JOOMLIC - All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Jooml!C - http://www.joomlic.com
 * 
 * @since		1.2
 *----------------------------------------------------------------------------
*/

// No direct access to this file
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.methods' );
jimport( 'joomla.environment.request' );

// classe du Module
class modiCcalendarHelper
{
	private function construct($params)
	{
		$this->catid = $params->get('mcatid');
		$this->time = $params->get('time');
		$this->number = $params->get('number');
		$page = JRequest::getVar('page', '0', 'get', 'int');

		if (!$page){
			$this->start='0';
		}
		if ($page){
			$this->start = $number*($page-1);
		}
		$this->template=$params->get('template');
		$this->format= $params->get('format');
				
		//Add Security 
		$mid = JRequest::getInt('id');
		if ((!$mid) || (!preg_match("/^[0-9]+$/", $mid))) {};
	
		$mItemid = JRequest::getVar('Itemid');
//		if ((!$mItemid) || (!preg_match("/^[0-9]+$/", $mItemid))) exit();
		if($this->itemid===NULL) $this->itemid = $mItemid;
		
		$this->date_start=date('Y-m-d');
		if(isset($_GET['date'])&&(!empty($_GET['date']))) $this->date_start=$_GET['date'];

		if($time==0) $this->addFilter('e.next', $this->date_start,'>=');
		if($this->catid!=0) $this->addFilter('e.catid', $this->catid);
	}

	function start($params)
	{
		$this->construct($params);
	}

	function addFilter($key, $var, $for=NULL){
		if($for==NULL) $for='=';
		$this->filter[$key]=' AND '.$key.$for.$var;
	}
	// Class Method
	function getStamp($params)
	{
		$this->start($params);
		// Prpare la requte
		$db		= JFactory::getDbo();
		$query	= $db->getQuery(true);
		
		// Slection de la requte
		$query->select(
			'e.id, e.title, e.alias, e.params, e.catid, e.image, e.file, e.next, e.dates, e.time, e.desc, e.address as address, e.place as place_name, e.city as city, e.coordinate as coordinate, c.title as cat_title, c.alias as cat_alias, c.color as cat_color' 
		);
		$query->from('`#__icagenda_events` AS e');
		$query->leftJoin('`#__icagenda_category` AS c ON c.id = e.catid');
		$query->leftJoin('`#__icagenda_events` AS l ON l.id = e.place');
		
		// where
		$where='e.state = 1';

		// ajout des filtres
		if(isset($this->filter)){
			foreach ($this->filter as $filter){
				$where.=$filter;
			}
		}

		$query->where($where);
		$query->order('e.next');
		$query.=' LIMIT 0, 1000';
		// requte
		$db->setQuery($query);
		$res = $db->loadObjectList();
		
		$days=$this->getDays($this->date_start, $this->format);
		
		foreach ($res as $r) {
			$next=$this->getNext($r->dates, $r->id);
			$datelist=$this->getDatelist($r->dates, $next);


			
			
// Requte Itemid
		$lang = JFactory::getLanguage();
		$locale = $lang->getlocale() ;
		setlocale( LC_TIME, $locale[0] ) ;

		$langcur = $lang->getTag();
		$langcurrent = $langcur;
		
		$db = JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('id AS idm, language AS lng')->from('#__menu')->where( "(link = 'index.php?option=com_icagenda&view=list') AND (published > 0) AND (language = '$langcurrent')" );
		$db->setQuery($query);
		$idm=$db->loadObject()->idm;
		$mItemid=$idm;
		
		if ($mItemid == NULL) {
		$db = JFactory::getDbo();
		$query	= $db->getQuery(true);
		$query->select('id AS noidm, language AS nolng')->from('#__menu')->where( "(link = 'index.php?option=com_icagenda&view=list') AND (published > 0) AND (language = '*')" );
		$db->setQuery($query);
		$noidm=$db->loadObject()->noidm;
		$noidm=$noidm;
		}
		
		if ($noidm == NULL && $mItemid == NULL) {
			echo '<div style="color:#a40505; font-weight: bold; text-align: center;">'.JText::_( 'MOD_ICCALENDAR_COM_ICAGENDA_MENULINK_UNPUBLISHED_MESSAGE' ).'</div><br>';
			$nolink = 1;
		}			
		
		if ($nolink == 1) {
			$urlevent = '#';
		}else {
			$lien = $mItemid;
			$eventnumber = $r->id;
//			$eventdate = $d;
//			$urlevent = JRoute::_('index.php?option=com_icagenda&amp;view=list&amp;layout=event&amp;Itemid='.$lien.$noidm.'&amp;id='.$eventnumber.'&amp;eventdate='.$eventdate);
			$urlevent = JRoute::_('index.php?option=com_icagenda&amp;view=list&amp;layout=event&amp;Itemid='.$lien.$noidm.'&amp;id='.$eventnumber);
		}
		$event=array(
				'id' => $r->id,
				'Itemid' => $mItemid,
				'url'=> $urlevent,
				'title' => $r->title,
				'image' => $r->image,
				'dates' => $r->dataini,
				'next' => date('Y-m-d', $next),
				'time' => $r->time,
				'address' => $r->address,
				'place' => $r->place,
				'cat_title' => $r->cat_title,
				'cat_color' => $r->cat_color,
			);

			foreach ($datelist as $d){
				foreach ($days as $k=>$dy){
					if($d==$dy['date']){
						array_push ($days[$k]['events'], $event);
					}
				}
			}
		}
		
		
		return $days;
	}
	
	function clickDate ($eventdate, $d)
	{
		$eventdate = $d;
		return $eventdate;
	}

	/***/


	 
	// Gnration des jours du mois
	function getDays ($d, $f)
	{

		$lang = JFactory::getLanguage();
		$locale = $lang->getlocale() ;
		setlocale( LC_TIME, $locale[0] ) ;

		//update default value, from 1.2.2 to 1.2.3
		if ($f == 'd-m-Y') {
			$f = '%d-%m-%Y';
		}
		
		// dtermine le mois et l'anne

		$ex_data=explode('-', $d);
		$mese=$ex_data[1];
		$anno=$ex_data[0];

		// Gnration du Calendrier
		$days = date("d", mktime(0, 0, 0, $mese+1, 0, $anno));
		$list = array();
		
				
		for($a=1; $a<=$days; $a++)
		{
			$list[$a]['date'] = date('Y-m-d', mktime(0, 0, 0, $mese, $a, $anno));
			$list[$a]['dateFormat'] = strftime($f, mktime(0, 0, 0, $mese, $a, $anno));
			$list[$a]['dateTitle'] = strftime($f, mktime(0, 0, 0, $mese, $a, $anno));
			$list[$a]['week'] = date('N', mktime(0, 0, 0, $mese, $a, $anno));
			$list[$a]['day'] = $a;
			$list[$a]['month'] = $mese;
			$list[$a]['year'] = $anno;
			$list[$a]['year'] = $anno;
			$list[$a]['events']=array();
		}
		return $list;
	}
	/***/
	
	/**
	 * liste des dates pour un vnement
	 */
	private function getDatelist($dates, $next)
	{
	
		$dates=unserialize($dates);
		$da=array();
		foreach($dates as $d){
			$d=$this->mkt($d);
			if($d>=$next){
				array_push($da, date('Y-m-d', $d));
			}
		}
		return $da;
	}

	// Format Date
	private function mkt($data)
	{
		$data=str_replace(' ', '-', $data);
		$data=str_replace(':', '-', $data);
		$ex_data=explode('-', $data);
		$ris=mktime($ex_data['3'], $ex_data['4'], '0', $ex_data['1'], $ex_data['2'], $ex_data['0']);
		return strftime($ris);
	}
	
	// 
	private function addDay ($mkt) 
	{
		return $mkt+82800;
	}

	/**
	 * Fonction de mise  jour de la date  venir (update si ncessaire)
	 */
	private function getNext ($dates, $id)
	{
		$dates=unserialize($dates);
		$today=time();
		$day= date('d');
		$m= date('m');
		$y= date('y');
		$today=mktime(0,0,0,$m,$day,$y);

		if(count($dates)){
				
			if ($next <= $today) {
				$dd = $this->mkt($dates[0]);
				foreach($dates as $a){
					$d=$this->mkt($a);
					if ($dd < $today){
						$next=date('Y-m-d', $dd);

					}
					elseif ($d>=$today){
						$next=date('Y-m-d', $d);

					}
				}
			}

						$db		= Jfactory::getDbo();
						$query	= $db->getQuery(true);
        				$query->clear();
						$query->update(' #__icagenda_events ');
						$query->set(' next = '.$db->Quote($next) );
						$query->where(' id = ' . (int) $id );
						$db->setQuery((string)$query);
						$db->query($query);
        				if (!$db->query()) {
        				    JError::raiseError(500, $db->getErrorMsg());
        					return false;
        				} else {
        					return true;
						}
		}
		return $next;
	}



	/***/

	/** Systme de navigation **/
	function getNav($date_start)
	{
		$option = 'index.php?option='.JRequest::getVar('option');
		$view = '&view='.JRequest::getVar('view');
		if(JRequest::getVar('layout'))$layout = '&layout='.JRequest::getVar('layout');
//		if(JRequest::getVar('task'))$task = '&task='.JRequest::getVar('task');
		$Itemid = '&Itemid='.JRequest::getVar('Itemid');
		if(JRequest::getVar('id'))$id = '&id='.JRequest::getVar('id');
		$Aurl = $option.$view.$layout.$task.$Itemid.$id;


		$ex_date=explode('-', $date_start);
		$mkt_date=$this->mkt($date_start);
		$year=$ex_date[0];
		$month=$ex_date[1];
		$day=1;

		if($month!=1){$backMonth=$month-1; $backYear=$year;}
		if($month==1){$backMonth=12; $backYear=$year-1;}
		if($month!=12){$nextMonth=$month+1; $nextYear=$year;}
		if($month==12){$nextMonth=1; $nextYear=$year+1;}
		$backYYear = $year-1;
		$nextYYear = $year+1;

//		$mainframe = JFactory::getApplication();
//		$isSefm = $mainframe->getCfg( 'sef' ); 
		
//		if ($isSefm == '1') {
//			$dateback='?date=';
//		}
//		if ($isSefm == '0') {
//			$dateback='&date=';
//		}
		

		$back='<a class="back icagendabtn" href="'.$Aurl.'&date='.$backYear.'-'.$backMonth.'-'.$day.'">&nbsp;&#9668&nbsp;</a>';
		$next='<a class="next icagendabtn" href="'.$Aurl.'&date='.$nextYear.'-'.$nextMonth.'-'.$day.'">&nbsp;&#9658&nbsp;</a>';

		$backY='<a class="back icagendabtn" href="'.$Aurl.'&date='.$backYYear.'-'.$month.'-'.$day.'"><small>&nbsp;&#9668&#9668&nbsp;</small></a>';
		$nextY='<a class="next icagendabtn" href="'.$Aurl.'&date='.$nextYYear.'-'.$month.'-'.$day.'"><small>&nbsp;&#9658;&#9658;&nbsp;</small></a>';

		$title=date('M-Y', $mkt_date);
		$lang = JFactory::getLanguage();
		$locale = $lang->getlocale() ;
		setlocale( LC_TIME, $locale[0] ) ;

	/** translate the month in the calendar module -- Leland Vandervort **/
 		$dateFormat = $title;

		// split out the month and year to obtain translation key for JText using joomla core translation
		$t_day = strftime("%d", strtotime("$dateFormat")); 
		$t_month = strftime("%B", strtotime("$dateFormat")); 
		$t_year = strftime("%Y", strtotime("$dateFormat"));

		// now resplice the title back together and call JText::
		$title = JText::_(strtoupper($t_month)) . ' ' . $t_year;
		$mois = JText::_(strtoupper($t_month));
		$annee = $t_year;

	/***/

		$html.='<div class="nav">'.$backY.$back.$nextY.$next.'<div class="title" style="text-transform: uppercase;">'.$title.'</div></div>';
//		$html.='<div class="nav">'.$backY.$nextY.'<div class="title" style="text-transform: uppercase;">'.$annee.'</div></div>';
//		$html.='<div class="nav">'.$back.$next.'<div class="title" style="text-transform: uppercase;">'.$mois.'</div></div>';

		return $html;
	}
	/***/
 
}
?>